# Add project specific ProGuard rules here.
# You can control the set of applied configuration files using the
# proguardFiles setting in build.gradle.
#
# For more details, see
#   http://developer.android.com/guide/developing/tools/proguard.html

# If your project uses WebView with JS, uncomment the following
# and specify the fully qualified class name to the JavaScript interface
# class:
#-keepclassmembers class fqcn.of.javascript.interface.for.webview {
#   public *;
#}

# Uncomment this to preserve the line number information for
# debugging stack traces.
#-keepattributes SourceFile,LineNumberTable

# If you keep the line number information, uncomment this to
# hide the original source file name.
#-renamesourcefileattribute SourceFile

# base file is this one
# https://medium.com/code-procedure-and-rants/android-my-standard-proguard-ffeceaf65521

# hide the original source file name.
#-renamesourcefileattribute SourceFile
-dontusemixedcaseclassnames
-dontskipnonpubliclibraryclassmembers
-verbose
# Optimization is turned off by default.Dex does not like code run
# through the ProGuard optimize andpreverify steps (and performs some
# of these optimizations on its own).
-dontoptimize
-dontpreverify

# Note that if you want to enableoptimization, you cannot just
# include optimization flags in your ownproject configuration file;
# instead you will need to point to the
# "proguard-android-optimize.txt" fileinstead of this one from your
# project.properties file.
##########
# Maintain all attributes - To avoidhaving to add each in several different places below
##########
-keepattributes

#Exceptions,InnerClasses,Signature,Deprecated,SourceFile,LineNumberTable,*Annotation*,EnclosingMethod
##########
# Android
##########
-keep public class * extends android.app.Activity
-keep public class * extends android.app.Application
-keep public class * extends android.app.Service
-keep public class * extends android.content.BroadcastReceiver
-keep public class * extends android.content.ContentProvider
-keep public class * extends android.app.backup.BackupAgentHelper
-keep public class * extends android.preference.Preference
# Data Binding
-dontwarn android.databinding.**
-keep class android.databinding.** { *; }
-keepclassmembers class * extends android.content.Context {
    public void *(android.view.View);
    public void *(android.view.MenuItem);
}

##########
# View - Gets and setters - keep setters in Views so that animations can still work.
# see http://proguard.sourceforge.net/manual/examples.html#beans
##########
-keepclassmembers public class * extends android.view.View {
    void set*(***);
    *** get*();
}

-keepclasseswithmembers class *{
public <init> (android.content.Context,android.util.AttributeSet);
}

##########
#Enums - For enumeration classes, see http://proguard.sourceforge.net/manual/examples.html#enumerations
##########
-keepclassmembers enum * { *; }

##########
# Parcelables: Mantain the parcelables working
##########
-keep class * implements android.os.Parcelable {public static final android.os.Parcelable$Creator *;
}

-keepclassmembers class * implements android.os.Parcelable {static ** CREATOR;
}
-keepclassmembers class **.R$* {public static <fields>;
}

#############
# Serializables
#############
#-keepclassmembers class * implements java.io.Serializable {
#static final long serialVersionUID;
#private static final java.io.ObjectStreamField[] serialPersistentFields;
#private voidwriteObject(java.io.ObjectOutputStream);
#private void readObject(java.io.ObjectInputStream);
#java.lang.Object writeReplace();
#java.lan g.Object readResolve();
#}

##########
# Kotlin
##########
-dontwarn kotlin.**
-dontnote kotlin.**
-keepclassmembers class **$WhenMappings {
<fields>;
}
# ServiceLoader support
-keepnames class kotlinx.coroutines.internal.MainDispatcherFactory {}
-keepnames class kotlinx.coroutines.CoroutineExceptionHandler {}

# Most of volatile fields are updated with AFU and should not be mangled
-keepclassmembernames class kotlinx.** {
    volatile <fields>;
}

#Ignore null checks at runtime
-assumenosideeffects class kotlin.jvm.internal.Intrinsics {static void checkParameterIsNotNull(java.lang.Object,java.lang.String);
}

#############
# BottomBar (Needed to call methods viareflection to customize it)
#############
-keep class android.support.design.internal.** { *; }

#############
# WebViews
#############
# If your project uses WebView with JS,uncomment the following
# and specify the fully qualified classname to the JavaScript interface
# class:
#-keepclassmembers class fqcn.of.javascript.interface.for.webview{
# public *;
#}
-keep class android.support.v8.renderscript.** { *; }
########################################
# External Libraries
########################################
#############
# Google Play Services
#############
-keep class com.google.android.gms.* {
*; }
-dontwarn com.google.android.gms.**
-keep public class com.google.vending.licensing.ILicensingService
-keep public class com.android.vending.licensing.ILicensingService
-dontnote **ILicensingService
-dontnote com.google.android.gms.gcm.GcmListenerService
-dontnote com.google.android.gms.**

-dontwarn com.google.android.gms.ads.**
#############
# Androidx Libs
#############

# Android architecture components: Lifecycle (https://issuetracker.google.com/issues/62113696 )
##########
# LifecycleObserver's empty constructor is considered to be unused by proguard
-keepclassmembers class * implements androidx.lifecycle.LifecycleObserver{<init>(...);
}
# ViewModel's empty constructor isconsidered to be unused by proguard
-keepclassmembers class * extends androidx.lifecycle.ViewModel {
<init>(...);
}
# keep Lifecycle State and Event enums values
-keepclassmembers class androidx.lifecycle.Lifecycle$State {
*; }
-keepclassmembers class androidx.lifecycle.Lifecycle$Event {
*; }

# keep methods annotated with @OnLifecycleEvent even if they seem to be unused
# (Mostly for LiveData.LifecycleBoundObserver.onStateChange(), but who knows)
#-keepclassmembers class * android.arch.lifecycle.OnLifecycleEvent


#############
# Firebase
#############
-dontnote com.google.firebase.**
-dontwarn com.google.firebase.crash.**

#############
# okhttp
##########
# JSR 305 annotations are for embedding nullability information.
-dontwarn javax.annotation.**

# A resource is loaded with a relative path so the package of this class must be preserved.
-keepnames class okhttp3.internal.publicsuffix.PublicSuffixDatabase

# Animal Sniffer compileOnly dependency to ensure APIs are compatible with older versions of Java.
-dontwarn org.codehaus.mojo.animal_sniffer.*

# OkHttp platform used only on JVM and when Conscrypt dependency is available.
-dontwarn okhttp3.internal.platform.ConscryptPlatform

#############
# Retrofit
#############
-dontnote okio.**
#############
# HttpClient Legacy (Ignore) -org.apache.http legacy
#############
-dontnote android.net.http.*
-dontnote org.apache.commons.codec.**
-dontnote org.apache.http.**

##########
# Glide
##########
-keep public class * implements com.bumptech.glide.module.GlideModule
-keep public enum com.bumptech.glide.load.resource.bitmap.ImageHeaderParser$** {
**[] $VALUES;
public *;
}
-dontnote com.bumptech.glide.**




#############
# Stetho
#############
-dontnote com.facebook.stetho.**


##########
# Crashlytics:
# Adding this in to preserve line numbers so that the stack traces can be remapped
##########
-renamesourcefileattribute SourceFile
-keepattributes SourceFile,LineNumberTable